#include <sourcemod>
#include <sdktools>
#pragma semicolon 1

new Handle:cvarHeeffectEnable;
new Handle:cvarFleffectEnable;
new Handle:cvarSmokeeffectEnable;

new PrecB = 0, PrecH = 0;
new Prec2B = 0, Prec2H = 0;

public Plugin:myinfo = 
{
	name = "Nade wave efect/Волны от дитонации гранат(через стены)",
	author = "Nek.'a 2x2",
	description = "Волны от дитонации гранат (через стены)",
	version = "1.3.1.7",
	url = "https://ggwp.site/"
};

/*
enum
{
	Sound_Event_HegrenadeDetonate
};

new const String:g_szSounds[][] = {
	"bomb/bombpl.wav"
};
*/

public OnPluginStart()
{
	//LoadTranslations("nade_wave_efect.phrases");

	cvarHeeffectEnable = CreateConVar("sm_heeffect_enable", "1", "Включить/выключить эффект взрыва боевой гранаты", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	cvarFleffectEnable = CreateConVar("sm_fleffect_enable", "1", "Включить/выключить эффект взрыва слеповой гранаты", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	cvarSmokeeffectEnable = CreateConVar("sm_smokeeffect_enable", "1", "Включить/выключить эффект взрыва дымовой гранаты", FCVAR_PLUGIN, true, 0.0, true, 1.0);

	AutoExecConfig(true, "nade_wave_efect");

	HookEvent("hegrenade_detonate", Event_HegrenadeDetonate, EventHookMode:1);
	HookEvent("flashbang_detonate", Event_FlashbangDetonate, EventHookMode:1);
	HookEvent("smokegrenade_detonate", Event_SmokegrenadeDetonate, EventHookMode:1);
}

public OnMapStart()
{
	// Автозагрузка материалов
	AddFileToDownloadsTable("materials/ggwp/sprites/laser_2v.vmt");
	AddFileToDownloadsTable("materials/ggwp/sprites/laser_2v.vtf");
	AddFileToDownloadsTable("materials/ggwp/sprites/halo01_2v.vmt");
	AddFileToDownloadsTable("materials/ggwp/sprites/halo01_2v.vtf");
	AddFileToDownloadsTable("materials/ggwp/effects/black.vmt");
	AddFileToDownloadsTable("materials/ggwp/effects/black.vtf");
	
	wave_Prec();
	
	/*decl String:szBuffer[PLATFORM_MAX_PATH];
	for(new i = 0; i < sizeof(g_szSounds); i++)
	{
		PrecacheSound(g_szSounds[i]);
		Format(szBuffer, sizeof(szBuffer), "sound/%s", g_szSounds[i]);
		if(FileExists(szBuffer))
			AddFileToDownloadsTable(szBuffer);
	}*/
}

wave_Prec()
{
	PrecB = PrecacheModel("materials/ggwp/sprites/laser_2v.vmt", true);
	PrecH = PrecacheModel("materials/ggwp/sprites/halo01_2v.vmt", true);
	Prec2B = PrecacheModel("materials/ggwp/effects/black.vmt", true);
	Prec2H = PrecacheModel("materials/ggwp/effects/black.vmt", true);
}

public Event_HegrenadeDetonate(Handle:event, const String:name[], bool:dontBroadcast)
{
	/*if(IsSoundPrecached(g_szSounds[Sound_Event_HegrenadeDetonate]))
		EmitSoundToAll(g_szSounds[Sound_Event_HegrenadeDetonate]);*/
		
	if(GetConVarInt(cvarHeeffectEnable) > 0)
	{
		new c = GetRandomInt(1, 5);
		if(c == 1)
		{
			new wave_i = GetClientOfUserId(GetEventInt(event, "userid"));
			if (wave_i > 0 && IsClientInGame(wave_i))	//Первая волна
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)	//т
				{
					wave_color[0] = 0;		//#000080 тёмно синяя
					wave_color[1] = 0;
					wave_color[2] = 128;
				}
				else
				{
					wave_color[0] = 0;			//#00a3cc
					wave_color[1] = 163;
					wave_color[2] = 204;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, PrecB, PrecH, 0, 0, 0.5, 20.0, 5.0, wave_color, 50, 0);
				TE_SendToAll();
			}

			if (wave_i > 0 && IsClientInGame(wave_i))	//вторая внешняя волна
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)	//т
				{
					wave_color[0] = 179;	//#b30000 тёмная вишня
					wave_color[1] = 0;
					wave_color[2] = 0;
				}
				else
				{
					wave_color[0] = 46;		//#2eb82e зелёный
					wave_color[1] = 184;
					wave_color[2] = 46;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 390.0, 10.0, PrecB, PrecH, 0, 0, 0.5, 20.0, 10.0, wave_color, 50, 0);
				TE_SendToAll();
			}
			
			if (wave_i > 0 && IsClientInGame(wave_i))	//третья волна ядро
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 128;		//#800000
					wave_color[1] = 0;
					wave_color[2] = 0;
				}
				else
				{
					wave_color[0] = 0;			//#005266
					wave_color[1] = 82;
					wave_color[2] = 102;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 50.0;	//значение высоты
				for (new i = 1; i <= 15; i++) // Создаем цикл. На этот раз радиус один. i просто счетчик высоты. Цилиндр будет высотой 150 единиц.
				{                           // Создаем маяк (кольцо) с нач. диаметром 50.0 ед. и конечным 51.0 единица, чтобы все работало.
				TE_SetupBeamRingPoint(wave_vec, 40.0, 41.0, PrecB, PrecH, 0, 0, 0.5, 10.0, 0.0, wave_color, 50, 0);
				//TE_SetupBeamRingPoint(wave_vec, 50.0, 51.0, PrecB, PrecH, 0, 15, 5.0, 2.0, 0.0, wave_color, 10, 0);
				TE_SendToAll();
				wave_vec[2] = wave_vec[2] + 1.0; // Добавляем + 1 единицу к координате Z, чтобы фигура росла в высоту.
				}
			}
		}
	
		if(c == 2)
		{
			new wave_i = GetClientOfUserId(GetEventInt(event, "userid"));
			if (wave_i > 0 && IsClientInGame(wave_i))	//Первая волна
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)	//т
				{
					wave_color[0] = 102;	//#b30000 фиолетовая
					wave_color[1] = 0;
					wave_color[2] = 204;
				}
				else
				{
					wave_color[0] = 0;			//#00a3cc
					wave_color[1] = 153;
					wave_color[2] = 255;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, PrecB, PrecH, 0, 0, 0.5, 20.0, 5.0, wave_color, 50, 0);
				TE_SendToAll();
			}

			if (wave_i > 0 && IsClientInGame(wave_i))	//вторая внешняя волна
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)	//т
				{
					wave_color[0] = 255;	//Красный
					wave_color[1] = 0;
					wave_color[2] = 0;
				}
				else
				{
					wave_color[0] = 0;		//#2eb82e тёмносиний
					wave_color[1] = 0;
					wave_color[2] = 102;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 390.0, 10.0, PrecB, PrecH, 0, 0, 0.5, 20.0, 10.0, wave_color, 50, 0);
				TE_SendToAll();
			}
			
			if (wave_i > 0 && IsClientInGame(wave_i))	//третья волна ядро
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 0;		//#800000
					wave_color[1] = 255;
					wave_color[2] = 0;
				}
				else
				{
					wave_color[0] = 0;			//#005266
					wave_color[1] = 255;
					wave_color[2] = 204;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 50.0;	//значение высоты
				for (new i = 1; i <= 15; i++) // Создаем цикл. На этот раз радиус один. i просто счетчик высоты. Цилиндр будет высотой 150 единиц.
				{                           // Создаем маяк (кольцо) с нач. диаметром 50.0 ед. и конечным 51.0 единица, чтобы все работало.
					TE_SetupBeamRingPoint(wave_vec, 40.0, 41.0, PrecB, PrecH, 0, 0, 0.5, 10.0, 0.0, wave_color, 50, 0);
					//TE_SetupBeamRingPoint(wave_vec, 50.0, 51.0, PrecB, PrecH, 0, 15, 5.0, 2.0, 0.0, wave_color, 10, 0);
					TE_SendToAll();
					wave_vec[2] = wave_vec[2] + 1.0; // Добавляем + 1 единицу к координате Z, чтобы фигура росла в высоту.
				}
			}
		}
		if(c == 3)
		{
			new wave_i = GetClientOfUserId(GetEventInt(event, "userid"));
			if (wave_i > 0 && IsClientInGame(wave_i))	//Первая волна
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)	//т
				{
					wave_color[0] = 102;		//#669999 Зёлёно серый
					wave_color[1] = 153;
					wave_color[2] = 153;
				}
				else
				{
					wave_color[0] = 0;			//#009900 Тёмно Зелёный 
					wave_color[1] = 153;
					wave_color[2] = 0;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, PrecB, PrecH, 0, 0, 0.5, 20.0, 5.0, wave_color, 50, 0);
				TE_SendToAll();
			}

			if (wave_i > 0 && IsClientInGame(wave_i))	//вторая внешняя волна
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 204;		//#cc00ff розовый
					wave_color[1] = 0;
					wave_color[2] = 255;
				}
				else
				{
					wave_color[0] = 102;			//#6600ff
					wave_color[1] = 0;
					wave_color[2] = 255;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 390.0, 10.0, PrecB, PrecH, 0, 0, 0.5, 20.0, 10.0, wave_color, 50, 0);
				TE_SendToAll();
			}
			
			if (wave_i > 0 && IsClientInGame(wave_i))	//третья волна ядро
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 204;		//#cc00ff розовый
					wave_color[1] = 0;
					wave_color[2] = 255;
				}
				else
				{
					wave_color[0] = 102;			//#6600ff
					wave_color[1] = 0;
					wave_color[2] = 255;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 50.0;	//значение высоты
				for (new i = 1; i <= 15; i++) // Создаем цикл. На этот раз радиус один. i просто счетчик высоты. Цилиндр будет высотой 150 единиц.
				{                           // Создаем маяк (кольцо) с нач. диаметром 50.0 ед. и конечным 51.0 единица, чтобы все работало.
				TE_SetupBeamRingPoint(wave_vec, 40.0, 41.0, PrecB, PrecH, 0, 0, 0.5, 10.0, 0.0, wave_color, 50, 0);
				//TE_SetupBeamRingPoint(wave_vec, 50.0, 51.0, PrecB, PrecH, 0, 15, 5.0, 2.0, 0.0, wave_color, 10, 0);
				TE_SendToAll();
				wave_vec[2] = wave_vec[2] + 1.0; // Добавляем + 1 единицу к координате Z, чтобы фигура росла в высоту.
				}
				
				//PrintToChatAll("\x01[Тест Режим] \x01 Третий эффект от гранаты", wave_i);
			}
		}
		
		if(c == 4)
		{
			new wave_i = GetClientOfUserId(GetEventInt(event, "userid"));
			if (wave_i > 0 && IsClientInGame(wave_i))	
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)	//т
				{
					wave_color[0] = 179;		//#000080 тёмно синяя
					wave_color[1] = 0;
					wave_color[2] = 0;
				}
				else
				{
					wave_color[0] = 0;			//#b30000 тёмно красный
					wave_color[1] = 0;
					wave_color[2] = 128;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 50.0;
				TE_SetupBeamRingPoint(wave_vec, 10.0, 400.0, PrecB, PrecH, 0, 0, 0.5, 40.0, 10.0, wave_color, 50, 0);
				TE_SendToAll();
				
				//PrintToChatAll("\x01[Тест Режим] \x03 Чётвёртый эффект от гранаты", wave_i);
			}
		}
		if(c == 5)
		{
			new wave_i = GetClientOfUserId(GetEventInt(event, "userid"));
			if (wave_i > 0 && IsClientInGame(wave_i))	//Первая волна
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)	//т
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				else
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, PrecB, PrecH, 0, 0, 0.5, 20.0, 5.0, wave_color, 50, 0);
				TE_SendToAll();
			}

			if (wave_i > 0 && IsClientInGame(wave_i))	//вторая внешняя волна
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)	//т
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				else
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 390.0, 10.0, PrecB, PrecH, 0, 0, 0.5, 20.0, 10.0, wave_color, 50, 0);
				TE_SendToAll();
			}
			
			if (wave_i > 0 && IsClientInGame(wave_i))	//третья волна ядро
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				else
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 50.0;	//значение высоты
				for (new i = 1; i <= 15; i++) // Создаем цикл. На этот раз радиус один. i просто счетчик высоты. Цилиндр будет высотой 150 единиц.
				{                           // Создаем маяк (кольцо) с нач. диаметром 50.0 ед. и конечным 51.0 единица, чтобы все работало.
				TE_SetupBeamRingPoint(wave_vec, 40.0, 41.0, PrecB, PrecH, 0, 0, 0.5, 10.0, 0.0, wave_color, 50, 0);
				//TE_SetupBeamRingPoint(wave_vec, 50.0, 51.0, PrecB, PrecH, 0, 15, 5.0, 2.0, 0.0, wave_color, 10, 0);
				TE_SendToAll();
				wave_vec[2] = wave_vec[2] + 1.0; // Добавляем + 1 единицу к координате Z, чтобы фигура росла в высоту.
				}
			}
		}
	}
}

public Event_FlashbangDetonate(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(GetConVarInt(cvarFleffectEnable) > 0)
	{
		new d = GetRandomInt(1, 3);
		if(d == 1)
		{
			new wave_i = GetClientOfUserId(GetEventInt(event, "userid"));
			if (wave_i > 0 && IsClientInGame(wave_i))
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 235;
					wave_color[1] = 219;
					wave_color[2] = 7;
				}
				else
				{
					wave_color[0] = 255;
					wave_color[1] = 255;
					wave_color[2] = 255;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 40.0;	//значение высоты
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, PrecB, PrecH, 0, 0, 0.5, 35.0, 0.0, wave_color, 50, 0);
				TE_SendToAll();
			}
			
			if (wave_i > 0 && IsClientInGame(wave_i))
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 235;
					wave_color[1] = 219;
					wave_color[2] = 7;
				}
				else
				{
					wave_color[0] = 255;
					wave_color[1] = 255;
					wave_color[2] = 255;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 80.0;	//значение высоты
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, PrecB, PrecH, 0, 0, 0.5, 35.0, 0.0, wave_color, 50, 0);
				TE_SendToAll();
			}
			
			if (wave_i > 0 && IsClientInGame(wave_i))
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 235;
					wave_color[1] = 219;
					wave_color[2] = 7;
				}
				else
				{
					wave_color[0] = 255;
					wave_color[1] = 255;
					wave_color[2] = 255;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 55.0;	//значение высоты
				for (new i = 1; i <= 15; i++) // Создаем цикл. На этот раз радиус один. i просто счетчик высоты. Цилиндр будет высотой 150 единиц.
				{                           // Создаем маяк (кольцо) с нач. диаметром 50.0 ед. и конечным 51.0 единица, чтобы все работало.
				TE_SetupBeamRingPoint(wave_vec, 40.0, 41.0, PrecB, PrecH, 0, 0, 0.5, 10.0, 0.0, wave_color, 50, 0);
				//TE_SetupBeamRingPoint(wave_vec, 50.0, 51.0, PrecB, PrecH, 0, 15, 5.0, 2.0, 0.0, wave_color, 10, 0);
				TE_SendToAll();
				wave_vec[2] = wave_vec[2] + 1.0; // Добавляем + 1 единицу к координате Z, чтобы фигура росла в высоту.
				}
				
				//PrintToChatAll("\x01[Тест Режим] \x03Первый эффект от флешки", wave_i);
			}
		}
		
		if(d == 2)
		{
			new wave_i = GetClientOfUserId(GetEventInt(event, "userid"));
			if (wave_i > 0 && IsClientInGame(wave_i))
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 153;	//993366 бледно красный
					wave_color[1] = 51;
					wave_color[2] = 102;
				}
				else
				{
					wave_color[0] = 204;	//cc6600 коричнеый
					wave_color[1] = 102;
					wave_color[2] = 0;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 40.0;	//значение высоты
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, PrecB, PrecH, 0, 0, 0.5, 35.0, 0.0, wave_color, 50, 0);
				TE_SendToAll();
			}
			
			if (wave_i > 0 && IsClientInGame(wave_i))
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 153;	//993366 бледно красный
					wave_color[1] = 51;
					wave_color[2] = 102;
				}
				else
				{
					wave_color[0] = 204;	//cc6600 коричнеый
					wave_color[1] = 102;
					wave_color[2] = 0;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 80.0;	//значение высоты
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, PrecB, PrecH, 0, 0, 0.5, 35.0, 0.0, wave_color, 50, 0);
				TE_SendToAll();
			}
			
			if (wave_i > 0 && IsClientInGame(wave_i))
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 0;		//#003300 чёрно зелёный
					wave_color[1] = 51;
					wave_color[2] = 0;
				}
				else
				{
					wave_color[0] = 0;	//#
					wave_color[1] = 0;
					wave_color[2] = 102;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 55.0;	//значение высоты
				for (new i = 1; i <= 15; i++) // Создаем цикл. На этот раз радиус один. i просто счетчик высоты. Цилиндр будет высотой 150 единиц.
				{                           // Создаем маяк (кольцо) с нач. диаметром 50.0 ед. и конечным 51.0 единица, чтобы все работало.
					TE_SetupBeamRingPoint(wave_vec, 40.0, 41.0, PrecB, PrecH, 0, 0, 0.5, 10.0, 0.0, wave_color, 50, 0);
					//TE_SetupBeamRingPoint(wave_vec, 50.0, 51.0, PrecB, PrecH, 0, 15, 5.0, 2.0, 0.0, wave_color, 10, 0);
					TE_SendToAll();
					wave_vec[2] = wave_vec[2] + 1.0; // Добавляем + 1 единицу к координате Z, чтобы фигура росла в высоту.
				}
			}
		}
		if(d == 3)
		{
			new wave_i = GetClientOfUserId(GetEventInt(event, "userid"));
			if (wave_i > 0 && IsClientInGame(wave_i))
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				else
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 40.0;	//значение высоты
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, PrecB, PrecH, 0, 0, 0.5, 35.0, 0.0, wave_color, 50, 0);
				TE_SendToAll();
			}
			
			if (wave_i > 0 && IsClientInGame(wave_i))
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				else
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 80.0;	//значение высоты
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, PrecB, PrecH, 0, 0, 0.5, 35.0, 0.0, wave_color, 50, 0);
				TE_SendToAll();
			}
			
			if (wave_i > 0 && IsClientInGame(wave_i))
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				else
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				wave_vec[2] += 55.0;	//значение высоты
				for (new i = 1; i <= 15; i++) // Создаем цикл. На этот раз радиус один. i просто счетчик высоты. Цилиндр будет высотой 150 единиц.
				{                           // Создаем маяк (кольцо) с нач. диаметром 50.0 ед. и конечным 51.0 единица, чтобы все работало.
					TE_SetupBeamRingPoint(wave_vec, 40.0, 41.0, PrecB, PrecH, 0, 0, 0.5, 10.0, 0.0, wave_color, 50, 0);
					//TE_SetupBeamRingPoint(wave_vec, 50.0, 51.0, PrecB, PrecH, 0, 15, 5.0, 2.0, 0.0, wave_color, 10, 0);
					TE_SendToAll();
					wave_vec[2] = wave_vec[2] + 1.0; // Добавляем + 1 единицу к координате Z, чтобы фигура росла в высоту.
				}
			}
		}
	}
}

public Event_SmokegrenadeDetonate(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(GetConVarInt(cvarSmokeeffectEnable) > 0)
	{
		new f = GetRandomInt(1, 4);
		if(f == 1)
		{
			new wave_i = GetClientOfUserId(GetEventInt(event, "userid"));
			if (wave_i > 0 && IsClientInGame(wave_i))
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 0;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 255;		//#ff66ff розовый
					wave_color[1] = 102;
					wave_color[2] = 255;
				}
				else
				{
					wave_color[0] = 255;		//#ffff99 светло жёлтый
					wave_color[1] = 255;
					wave_color[2] = 153;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				wave_vec[2] += 20.0;	//значение высоты
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 390.0, 10.0, Prec2B, Prec2H, 0, 0, 3.0, 2.0, 1.0, wave_color, 25, 0);
				TE_SendToAll();
			}
		
			if (wave_i > 0 && IsClientInGame(wave_i))	//Вторая волна
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 0;
					wave_color[1] = 0;
					wave_color[2] = 0;
				}
				else
				{
					wave_color[0] = 0;
					wave_color[1] = 0;
					wave_color[2] = 0;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, Prec2B, Prec2H, 0, 0, 3.0, 5.0, 1.0, wave_color, 25, 0);
				TE_SendToAll();
			}
		}
		
		if(f == 2)
		{
			new wave_i = GetClientOfUserId(GetEventInt(event, "userid"));
			if (wave_i > 0 && IsClientInGame(wave_i))
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 255;
					wave_color[1] = 0;
					wave_color[2] = 255;
				}
				else
				{
					wave_color[0] = 26;
					wave_color[1] = 255;
					wave_color[2] = 26;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, PrecB, PrecH, 0, 0, 3.0, 30.0, 1.0, wave_color, 25, 0);
				TE_SendToAll();
			}
			
			if (wave_i > 0 && IsClientInGame(wave_i))	//Вторая волна
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 255;
					wave_color[1] = 0;
					wave_color[2] = 255;
				}
				else
				{
					wave_color[0] = 26;
					wave_color[1] = 255;
					wave_color[2] = 26;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				wave_vec[2] += 20.0;	//значение высоты
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 390.0, 10.0, PrecB, PrecH, 0, 0, 3.0, 30.0, 1.0, wave_color, 25, 0);
				TE_SendToAll();
			}
		}
		
		if(f == 3)
		{
			new wave_i = GetClientOfUserId(GetEventInt(event, "userid"));
			if (wave_i > 0 && IsClientInGame(wave_i))
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 102;		//#660033 тёмно вишнёвый
					wave_color[1] = 0;
					wave_color[2] = 51;
				}
				else
				{
					wave_color[0] = 102;		//#66ccff светло синий
					wave_color[1] = 204;
					wave_color[2] = 255;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, PrecB, PrecH, 0, 0, 9.0, 10.0, 10.0, wave_color, 25, 0);
				TE_SendToAll();
			}
			
			if (wave_i > 0 && IsClientInGame(wave_i))	//Вторая волна
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = 102;		//#660033 тёмно вишнёвый
					wave_color[1] = 0;
					wave_color[2] = 51;
				}
				else
				{
					wave_color[0] = 102;		//#66ccff светло синий
					wave_color[1] = 204;
					wave_color[2] = 255;
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				wave_vec[2] += 20.0;	//значение высоты
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 390.0, 10.0, PrecB, PrecH, 0, 0, 3.0, 30.0, 1.0, wave_color, 25, 0);
				TE_SendToAll();
			}
		}
		if(f == 4)
		{
			new wave_i = GetClientOfUserId(GetEventInt(event, "userid"));
			if (wave_i > 0 && IsClientInGame(wave_i))
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				else
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 10.0, 390.0, PrecB, PrecH, 0, 0, 9.0, 10.0, 10.0, wave_color, 25, 0);
				TE_SendToAll();
			}
			
			if (wave_i > 0 && IsClientInGame(wave_i))	//Вторая волна
			{
				decl wave_color[4], Float:wave_vec[3];
				wave_color[1] = 0;
				wave_color[3] = 255;
				if (GetClientTeam(wave_i) == 2)
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				else
				{
					wave_color[0] = GetRandomInt(0, 255);
					wave_color[1] = GetRandomInt(0, 255);
					wave_color[2] = GetRandomInt(0, 255);
				}
				wave_vec[0] = GetEventFloat(event, "x");
				wave_vec[1] = GetEventFloat(event, "y");
				wave_vec[2] = GetEventFloat(event, "z");
				wave_vec[2] += 20.0;	//значение высоты
				if (PrecB == 0) wave_Prec();
				TE_SetupBeamRingPoint(wave_vec, 390.0, 10.0, PrecB, PrecH, 0, 0, 3.0, 30.0, 1.0, wave_color, 25, 0);
				TE_SendToAll();
			}
		}
	}
}